#ifndef __EPAPER_H
#define __EPAPER_H
#include "sys.h"
//250*122///////////////////////////////////////

#define MONOMSB_MODE 1
#define MONOLSB_MODE 2 
#define RED_MODE     3

#define MAX_LINE_BYTES 16// =128/8
#define MAX_COLUMN_BYTES  296

#define ALLSCREEN_GRAGHBYTES	4736

///////////////////////////GPIO Settings//////////////////////////////////////////////////////

#define	Epaper_BUSY   PEin(13) 				  //BUSYź(GPIO_ReadInputDataBit(GPIOE,GPIO_Pin_13))
#define	Epaper_RESET  PEout(14)  				//RESETź
#define	Epaper_DC     PEout(15)  				//D/C#ź  
#define	Epaper_CS     PDout(8)  				//Ƭѡź
#define	Epaper_SCK    PDout(9)  				//clkź
#define	Epaper_SDO    PDout(10)  				//SDO

		
void EpaperIO_Init(void);
void Epaper_READBUSY(void);
void Epaper_Write_Command(u8 cmd);
void Epaper_Write_Data(u8 data);

void EPD_HW_Init(void); //ֽʼ
void EPD_Part_Init(void); //ֲֽˢ³ʼ

void EPD_Part_Update(void); 
void EPD_Update(void);

void EPD_WhiteScreen_BW(void);
void EPD_WhiteScreen_Black(void);
void EPD_WhiteScreen_White(void);
extern void EPD_Part_off(void);
extern  void EPD_DeepSleep(void);
//Display 
void EPD_WhiteScreen_ALL(unsigned char *datas);
void EPD_SetRAMValue_BaseMap(unsigned char * datas);
void EPD_Dis_Part(unsigned int x_start,unsigned int y_start,unsigned char * datas,unsigned int PART_COLUMN,unsigned int PART_LINE);
void EPD_Dis_Part_myself(unsigned int x_startA,unsigned int y_startA,unsigned char * datasA,
	                       unsigned int x_startB,unsigned int y_startB,unsigned char * datasB,
												 unsigned int x_startC,unsigned int y_startC,unsigned char * datasC,
												 unsigned int x_startD,unsigned int y_startD,unsigned char * datasD,
											   unsigned int x_startE,unsigned int y_startE,unsigned char * datasE,
												 unsigned int PART_COLUMN,unsigned int PART_LINE
	                      );


#endif


